import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Category, CategoryParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询课程分类
 */
export async function pageCategory(params: CategoryParam) {
  const res = await request.get<ApiResult<PageResult<Category>>>(
    MODULES_API_URL + '/booking/category/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询课程分类列表
 */
export async function listCategory(params?: CategoryParam) {
  const res = await request.get<ApiResult<Category[]>>(
    MODULES_API_URL + '/booking/category',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加课程分类
 */
export async function addCategory(data: Category) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改课程分类
 */
export async function updateCategory(data: Category) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除课程分类
 */
export async function removeCategory(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/category/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除课程分类
 */
export async function removeBatchCategory(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/category/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询课程分类
 */
export async function getCategory(id: number) {
  const res = await request.get<ApiResult<Category>>(
    MODULES_API_URL + '/booking/category/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
